// C Source File
// Created 1/1/2006; 10:07:00 AM
// Tron v1.00 - By Tyler Cassidy
// (C) Copyright 2006 Tyler Cassidy. All Rights Reserved.
// Email: altadogsledder89@yahoo.ca
//        tyler@tylerc.org
// Website: none yet
// ** Note: I will not be responsible for anything that this game game does to your calculator!

// Definitions
// #define MIN_AMS 200 // Only Enable this if you are not using TIGCC IDE

// TMM_ = Tron Main Menu Defintions
#define TMM_SXL ((LCD_WIDTH - 65) / 2) // Calculates where to place Selection on X-axis
// TLM_ = Tron Link Menu
#define TLM_SXL TMM_SXL // Calculates where to place Selection on X-axis
// TPTM_ = Tron Play Tron Menu Definitons
#define TPTM_SXL ((LCD_WIDTH - 80) / 2) // Calculates where to play Selection on X-axis
// TGPM_ = Tron Game Pause Menu
#define TGPM_SXL ((LCD_WIDTH - 85) / 2) // For Centered Pause Menu
// TGGOM_ = Tron Game Game Over Menu
#define TGGOM_SXL ((LCD_WIDTH - 100) / 2) // Game Over Menu Left on X-axis

// Header Files
#include <tigcclib.h> // All TIGCC Header Files
#include "extgraph.h" // ExtGraph Library v2.00 B5
#include "tron.h" // Tron Header File
#include "engine.h" // Game Engine Header File

// Game Logo Function - void menu_gamelogo(void)
void menu_GameLogo(void) {
	// Draw the Game Logo - game_logo - 79x8
	GraySpriteX8_XOR((LCD_WIDTH - 80) / 2, 5, 8, game_logo, game_logo, 10, GrayGetPlane(DARK_PLANE), GrayGetPlane(LIGHT_PLANE));
	
	// Now my name
	GrayDrawStrExt((LCD_WIDTH - 45) / 2, 15, "Tyler Cassidy", A_NORMAL, F_4x6);

	// End of Game Logo Function
}

// Draw Panes Function (centered) - void menu_DrawPanes(short width)
void menu_DrawPanes(short width) {
	short left_pane, right_pane;
	
	// Lets calculate where to go
	left_pane = (LCD_WIDTH - width - 1) / 2;
	right_pane = left_pane + width;
	
	// Lets Draw the Panes
	GrayDrawLine(left_pane, 0, left_pane, TG_LCDH, 3); // Left Side
	GrayDrawLine(left_pane - 1, 0, left_pane - 1, TG_LCDH, 3); // Left Side
	GrayDrawLine(right_pane, 0, right_pane, TG_LCDH, 3); // Right Side
	GrayDrawLine(right_pane + 1, 0, right_pane + 1, TG_LCDH, 3); // Right Side
	
	// End of Draw Panes Function
}

// Menu Draw Selector - void menu_DrawSelector(short x_left, short y_top, short x_width, short y_spacing)
void menu_DrawSelector(short x_left, short y_top, short x_width, short y_spacing) {
	// Lets setup i short variable
	short i;
	
	/// Lets Draw in the Pointer
	// Top Part First
	for(i=x_left + x_width; i>=x_left; i--) {
		GrayDrawLine(i, y_top, i, y_top, 2); // Draw Pixel
		slow_game(100); // Slow Down
	}
	
	// Now the Y part
	for(i=y_top; i<=y_top + y_spacing; i++) {
		GrayDrawLine(x_left, i, x_left, i, 2); // Draw Pixel
		slow_game(100); // Slow Down
	}
	
	// Now for the Bottom of the Pointer, the Last Part
	for(i=x_left; i<=x_left + x_width; i++) {
		GrayDrawLine(i, y_top + y_spacing, i, y_top + y_spacing, 2); // Draw Pixel
		slow_game(100); // Slow Down
	}
	
	// End of Menu Draw Selector
}

// Menu Selector Mover - void menu_MoveSelector(short mov_dir, short point_loc, short y_top, short x_left, short x_spacing, short y_spacing, short menu_selections)
void menu_MoveSelector(short mov_dir, short point_loc, short y_top, short x_left, short x_spacing, short y_spacing) {
	short int i, mms_y1, mms_y2;
	mms_y1 = mms_y2 = 0; // No Warnings
	
	// Lets Calculate some stuff
	if (mov_dir == 1) {
		mms_y1 = y_top + y_spacing + ((point_loc - 1) * y_spacing);
		mms_y2= y_top + ((point_loc - 1) * y_spacing);
	}
	if (mov_dir == -1) {
		mms_y1 = y_top + ((point_loc - 1) * y_spacing);
		mms_y2 = y_top + y_spacing + ((point_loc - 1) * y_spacing);
	}
	
	/// Lets Delete The Parts we need to
	// First Line on X-axis
	for(i=x_left + x_spacing; i>=x_left; i--) {
		GrayDrawLine(i, mms_y2, i, mms_y2, 0); // Clear Pixel
		slow_game(100); // Slow Down
	}
	
	// Line on y-axis now
	for(i=0; i<=y_spacing; i++) {
		if (mov_dir == 1) GrayDrawLine(x_left, mms_y2 + i, x_left, mms_y2 + i, 0); // Clear Pixel downwards
		if (mov_dir == -1) GrayDrawLine(x_left, mms_y2 - i, x_left, mms_y2 - i, 0); // Clear Pixel upwards
		slow_game(100); // Slow Down
	}
	
	/// Lets Draw in the parts now
	// Line on y-axis first
	for(i=0; i<=y_spacing; i++) {
		if (mov_dir == 1) GrayDrawLine(x_left, mms_y1 + i, x_left, mms_y1 + i, 2); // Draw Pixel downwards
		if (mov_dir == -1) GrayDrawLine(x_left, mms_y1 - i, x_left, mms_y1 - i, 2); // Draw Pixel upwards
		slow_game(100); // Slow Down
	}
	
	// Lets calculate where on y-axis should line be for next line
	if (mov_dir == 1) mms_y2 = mms_y1 + y_spacing;
	if (mov_dir == -1) mms_y2 = mms_y1 - y_spacing;
	
	// Line on x-axis now
	for(i=x_left; i<=x_left + x_spacing; i++) {
		GrayDrawLine(i, mms_y2, i, mms_y2, 2); // Draw Pixel
		slow_game(100); // Slow Down
	}
	
	// End of Menu Selector Mover
}

// Game Over Sub Menu - voidmenu_SubGameOver(short height_mon)
void menu_SubGameOver(short height_mon) {
	char ScoreToSay[12];
	
	// Lets Clear a patch
	clear_patch(TGGOM_SXL, 80, 20, height_mon);
	
	// Now some nice borders
	GrayDrawLine(TGGOM_SXL, 20, TGGOM_SXL, 20 + height_mon, 3); // Left Side
	GrayDrawLine(TGGOM_SXL, 20, TGGOM_SXL + 80, 20, 3); // Top
	GrayDrawLine(TGGOM_SXL, 20 + height_mon, TGGOM_SXL + 80, 20 + height_mon, 3); // Bottom
	GrayDrawLine(TGGOM_SXL + 80, 20, TGGOM_SXL + 80, 20 + height_mon, 3); // Right Side
	
	// Lets draw in Game Logo and Game Over and your status, than the score - 79x8
	GraySpriteX8_XOR(TGGOM_SXL + 1, 22, 8, game_logo, game_logo, 10, GrayGetPlane(DARK_PLANE), GrayGetPlane(LIGHT_PLANE)); // Logo Drawn
	GrayDrawStrExt(TGGOM_SXL + 4, 32, "Game Over", A_NORMAL, F_8x10); // Game Over

	if (game_over == 1) GrayDrawStrExt(TGGOM_SXL + 16, 44, "You Lose", A_NORMAL, F_6x8); // You Lose
	if (game_over == 2) GrayDrawStrExt(TGGOM_SXL + 16, 44, "You Win!", A_NORMAL, F_6x8); // You Win!
	if (game_over == 3) GrayDrawStrExt(TGGOM_SXL + 16, 44, "You Tie!", A_NORMAL, F_6x8); // You Tie!

  sprintf(ScoreToSay, "Score: %d", game_score);
  GrayDrawStrExt(TGGOM_SXL + 10, 54, ScoreToSay, A_NORMAL, F_6x8); // Show Score
	
	// End of Game Over Sub Menu
}

// Main Menu Selector Mover - void MM_MoveSelector(short mov_dir)
void MM_MoveSelector(short mov_dir) {
  // Lets not go off the scale
  if (mov_dir == 1 && mm_selector == 3) return; // Cannot go down no more
  if (mov_dir == -1 && mm_selector == 1) return; // Cannot go up no more

  // Lets Draw the Selection
  menu_MoveSelector(mov_dir, mm_selector, 28, TMM_SXL - 4, 78, 11);
  
  // Lets update mm_selector
  if (mov_dir == 1) mm_selector++;
  if (mov_dir == -1) mm_selector--;
  	
	// End of Main Menu Selector Mover
}

// Introduction Screen - void show_intro(void)
void show_intro(void) {
	// Lets Clear the Screen
	GrayClearScreen();
	
	// Lets draw in Logo & By Sprites
	GraySpriteX8_XOR((LCD_WIDTH - 130) / 2, 31, 19, intlogo_l1, intlogo_l2, 17, GrayGetPlane(DARK_PLANE), GrayGetPlane(LIGHT_PLANE));
	GraySpriteX8_XOR((LCD_WIDTH - 106) / 2, 53, 15, intby_spr, intby_spr, 14, GrayGetPlane(DARK_PLANE), GrayGetPlane(LIGHT_PLANE));
	
	// Now some text
	GrayDrawStrExt((LCD_WIDTH - 66) / 2, 75, "Press Enter", A_NORMAL, F_6x8); // Press Enter
	
	// Now for Key Input
	while(1) {
		if (!OSdequeue(&key, kbq)) {
			// Enter/2nd Key
			if (key == KEY_ENTER) {
				game_sequence = MAIN_MENU; // Goto Main Menu Sequence
				mm_selector = 1; // Set Main Menu Selector to 1
				break; // Break out of here
			}
			// Esc/F5 Key
			if (key == KEY_F5 || key == KEY_ESC) {
				game_sequence = QUIT_GAME; // Go into Quit Game Sequence
				break; // Break out of this loop
			}
		}
	}
	// End of Introduction Screen
}

// Main Menu - void show_mainmenu(void)
void show_mainmenu(void) {
	// Clear Screen
	GrayClearScreen();
	
	// Lets Draw the Divider Lines - Definitions Used, look at page top
  menu_DrawPanes(90);
	
  // Draw the Logo
  menu_GameLogo();
	
	// Lets add the Selections
	FontSetSys(F_6x8);
	GrayDrawStr(TMM_SXL, 30, "Play Tron", A_NORMAL); // TMM_SXL = Selection X Location
	GrayDrawStr(TMM_SXL, 41, "Highscores", A_NORMAL);
	GrayDrawStr(TMM_SXL, 52, "Exit Game", A_NORMAL);
	
	// Lets draw the Selector on Play Tron
	menu_DrawSelector(TMM_SXL - 4, 28 + ((mm_selector - 1) * 11), 78, 11); // TMM_PWL = Tron Main Menu Pain Width Left x-location
	
	// Lets setup the Main Menu Loop
	while(1) {
		// Keyboard Input
		if (!OSdequeue(&key, kbq)) {
			// Enter/2nd Key
			if (key == KEY_ENTER) {
				// Where to go
				// 1 = Play Tron
				// 2 = High Scores
				// 3 = Quit Game
				if (mm_selector == 1) game_sequence = GAME_SETUP; // Play a Game of Tron
				if (mm_selector == 2) game_sequence = HIGHSCORES_MENU; // Highscores
				if (mm_selector == 3) game_sequence = QUIT_GAME; // Quit Game
				break; // Break out of Main Menu Loop
			}
			// Esc/F5 Key
			if (key == KEY_ESC || key == KEY_F5) {
				game_sequence = QUIT_GAME; // Goto Quit Game Sequence
				break; // Break out of this loop!
			}
			// Down Key Hit
			if (key == KEY_DOWN) MM_MoveSelector(1); // 1 = down, -1 = up
			// Up Key Hit
			if (key == KEY_UP) MM_MoveSelector(-1); // -1 = up, 1 = down
		}
	}
	// End of Main Menu
}

// Show Game Highscores Menu - void show_gamescores(void)
void show_gamescores(void) {
	short i;
	char PlaceToStr[2], ScoreToStr[2];
	
	// Clear Screen
	GrayClearScreen();
	
	// Lets make some panes 156 pixels wide
	menu_DrawPanes(90);
	
	// Lets Draw the Logo and Page Title
	menu_GameLogo();
	GrayDrawStrExt((LCD_WIDTH - 61) / 2, 22, "Highscores", A_NORMAL, F_6x8);
	GrayDrawLine((LCD_WIDTH - 61) / 2, 30, ((LCD_WIDTH - 61) / 2) + 60, 30, 3); // Underline "Highscores"
	
	// Lets Draw in the static information
	FontSetSys(F_4x6); // 4x6 font
	GrayDrawStr((LCD_WIDTH - 80) / 2, 33, "Place", A_NORMAL);
	GrayDrawStr((LCD_WIDTH - 10) / 2, 33, "Score", A_NORMAL);
	GrayDrawLine((LCD_WIDTH - 80) / 2, 39, ((LCD_WIDTH - 80) / 2) + 19, 39, 3); // Underline Place
	GrayDrawLine((LCD_WIDTH - 10) / 2, 39, ((LCD_WIDTH - 10) / 2) + 19, 39, 3); // Underline Score
	
	// Lets Now Load the scores
	for(i=1; i<=gamehighscores.num_scores; i++) {
		// Lets Draw the Place
		sprintf(PlaceToStr, "%d", i);
		GrayDrawStr((LCD_WIDTH - 80) / 2, 40 + ((i - 1) * 6), PlaceToStr, A_NORMAL);
		
		// Lets Draw in the score
		sprintf(ScoreToStr, "%ld", gamehighscores.score[i - 1]);
		GrayDrawStr((LCD_WIDTH - 10) / 2, 40 + ((i - 1) * 6), ScoreToStr, A_NORMAL);
	}
	
  // Run High Scores Loop	
	while(1) {
		// Keyboard Detection
		if (!OSdequeue(&key, kbq)) {
			// F5 Key Hit
			if (key == KEY_F5) {
				game_sequence = QUIT_GAME; // Goto Quit Game Sequence
				break; // break out of Loop
			}
			
			// Any Other Key Hit
			else {
			  game_sequence = MAIN_MENU; // Goto Main Menu Sequence
			  break; // Break out of loop
			}
		}
	}

	// End of Show Game Highscoes Menu
}

// Play Tron Menu - void show_playtronmenu(void)
void show_playtronmenu(void) {
	// Clear Screen
	GrayClearScreen();
	
	// Draw Panes 100 Pixels Wide
	menu_DrawPanes(100);
	
	// Draw in Logo and Page Title
	menu_GameLogo();
	GrayDrawStrExt((LCD_WIDTH - 55) / 2, 22, "Play Tron", A_NORMAL, F_6x8);
	GrayDrawLine((LCD_WIDTH - 55) / 2, 30, ((LCD_WIDTH - 55) / 2) + 54, 30, 3); // Underline "Play Tron"
	
	// Draw in selections and menu
	GrayDrawStr(TPTM_SXL, 50, "Play Tron", A_NORMAL);
	GrayDrawStr(TPTM_SXL, 61, "Back", A_NORMAL);
	GrayDrawStrExt(TPTM_SXL, 38, "Game Speed:", A_NORMAL, F_4x6);
	GrayDrawStrExt(TPTM_SXL, 72, "Use Left/Right arrows for", A_NORMAL, F_4x6);
	GrayDrawStrExt(TPTM_SXL, 78, "Speed Selection.", A_NORMAL, F_4x6);
	
	// Lets draw in the speed selection
  if (game_speed == 1) GrayDrawStr(TPTM_SXL + 45, 36, "Easy", A_NORMAL);
  if (game_speed == 2) GrayDrawStr(TPTM_SXL + 45, 36, "Normal", A_NORMAL);
  if (game_speed == 3) GrayDrawStr(TPTM_SXL + 45, 36,  "Hard", A_NORMAL);
  if (game_speed == 4) GrayDrawStr(TPTM_SXL + 45, 36, "Insane", A_NORMAL);
	
	// Lets setup and draw the selector
	pt_selector = 1; // Set Selector to 1
	menu_DrawSelector(TPTM_SXL - 4, 48, 88, 11);
	
	// Play Tron Menu Loop
	while(1) {
		// Keyboard Detection
		if (!OSdequeue(&key, kbq)) {
			// Left/Right Arrow Key Hit
			if (key == KEY_RIGHT && game_speed < 4) game_speed++; // Increment Speed
			if (key == KEY_LEFT && game_speed > 1) game_speed--; // Decrement Speed
			if (key == KEY_RIGHT || key == KEY_LEFT) {
				clear_patch(TPTM_SXL + 45, 35, 36, 7); // Clear the Patch up
				if (game_speed == 1) GrayDrawStr(TPTM_SXL + 45, 36, "Easy", A_NORMAL);
        if (game_speed == 2) GrayDrawStr(TPTM_SXL + 45, 36, "Normal", A_NORMAL);
        if (game_speed == 3) GrayDrawStr(TPTM_SXL + 45, 36,  "Hard", A_NORMAL);
        if (game_speed == 4) GrayDrawStr(TPTM_SXL + 45, 36, "Insane", A_NORMAL);
			}
			
			// Up/Down Key Hit
			if (key == KEY_UP && pt_selector > 1) {
				menu_MoveSelector(-1, 2, 48, TPTM_SXL - 4, 88, 11); // Move Selector Up
				pt_selector--; // Decrement Selector
			}
			if (key == KEY_DOWN && pt_selector < 2) {
				menu_MoveSelector(1, 1, 48, TPTM_SXL - 4, 88, 11); // Move Selector Down
				pt_selector++; // Increment Selector
			}
			
			// Enter Key Hit
			if (key == KEY_ENTER) {
				if (pt_selector == 1) {
					game_on = 0; // Game is not on.
					game_sequence = PLAY_GAME; // Goto Play Game Sequence;
					break; // Break out of this loop
				}
				if (pt_selector == 2) {
					game_sequence = MAIN_MENU; // Goto Main Menu Sequence
					break; // Break out of loop
				}
			}
			
			// Escape Key Hit
			if (key == KEY_ESC) {
				game_sequence = MAIN_MENU; // Goto Main Menu Sequence
				break; // Break out of this loop
			}
			
			// F5 Key Hit
			if (key == KEY_F5) {
				game_sequence = QUIT_GAME; // Goto Quit Game Sequence
				break; // Break out of this loop
			}
		}
	}
	
	/// End of Play Tron Menu
}

// Pause Menu - void show_pausemenu(void)
void show_pausemenu(void) {
	// Game is now paused
	game_paused = 1;
	
	// Lets save the screen contents
	memcpy(DarkPlaneData, GrayGetPlane(DARK_PLANE), LCD_SIZE);
	memcpy(LightPlaneData, GrayGetPlane(LIGHT_PLANE), LCD_SIZE);
	
	// Lets make a border and than Clear a Patch
	GrayDrawLine(TGPM_SXL, 20, TGPM_SXL + 84, 20, 3); // Top
	GrayDrawLine(TGPM_SXL, 21, TGPM_SXL, 51, 3); // Left
	GrayDrawLine(TGPM_SXL + 85, 21, TGPM_SXL + 85, 51, 3); // Right
	GrayDrawLine(TGPM_SXL, 52, TGPM_SXL + 84, 52, 3); // Bottom
	clear_patch(TGPM_SXL + 1, 83, 21, 30); // Clear Patch
	
	// Lets Draw Game Logo, Pause Menu Text and Information - 79x8
	GraySpriteX8_XOR((LCD_WIDTH - 80) / 2, 22, 8, game_logo, game_logo, 10, GrayGetPlane(DARK_PLANE), GrayGetPlane(LIGHT_PLANE)); // Logo
	GrayDrawStrExt((LCD_WIDTH - 67) / 2, 32, "Game Paused", A_NORMAL, F_6x8); // Title
	GrayDrawStrExt(TGPM_SXL + 2, 40, "Press Esc to Quit Game", A_NORMAL, F_4x6); // Instruction 1
	GrayDrawStrExt(TGPM_SXL + 2, 46, "Press Enter to Continue", A_NORMAL, F_4x6); // Instruction 2
	
	// Pause Menu Loop
	while(1) {
		// Key Detection
		if (!OSdequeue(&key, kbq)) {
			// Esc Key - Goto Main Menu
			if (key == KEY_ESC) {
				game_sequence = MAIN_MENU; // Goto Main Menu Sequence
				game_over = 1; // 1 = You Lose
				game_on = 0; // Turn Game off
				break; // Break Out
			}
			
			// Enter Key - Unpause Game
			if (key == KEY_ENTER) {
				game_paused = 0; // Game Unpaused
				break; // Break out of here
			}
			
			// F5 Key - Quit Game
			if (key == KEY_F5) {
				game_sequence = QUIT_GAME; // Goto Quit Game Sequence
				game_over = 4; // 4 = Kill Game, Abort
				game_on = 0; // Turn Game Off
				break; // Break out of this loop
			}
		}
	}
	
	// Lets restore the Screen and unpause the Game
	memcpy(GrayGetPlane(DARK_PLANE), DarkPlaneData, LCD_SIZE);
	memcpy(GrayGetPlane(LIGHT_PLANE), LightPlaneData, LCD_SIZE);
	
	// End of Pause Menu
}

// Game Over Menu - void show_gameover(void)
void show_gameover(void) {
	// Lets Draw in the Base of it
	menu_SubGameOver(44);
	
	// Lets wait for a key press
	while(1) {
		// Key Detection
		if (!OSdequeue(&key, kbq)) {
			// F5 Key
			if (key == KEY_F5) {
				game_sequence = QUIT_GAME; // Goto Quit Game Sequence
				break; // Break Loop
			}
			
			// Any Other Key
			else {
				game_sequence = MAIN_MENU; // Goto Main Menu Sequence
				break; // Break Loop
			}
		}
	}
	
	// End of Game Over Menu
}